module Partoche.Partitions.Gammes where
{-
note (1/8) (G,9)
Prim (Note (1 % 8) (G,9))
it :: Num t => Music (PitchClass, t)

split partition (segments, 
byPartition: change duration (/2^n with random n)

todo: analyze bolero Ravel
gamme ré majeur
   g
---fs
   e
---d
   cs
---b
   a
---g
   fs
---e
   d
-  c
   b
-  a

playDev 3 $ partition $ map (\p -> instrument Violin p) $ tourbillonJigue 4
-}

import Euterpea

-- | Gamme
-- French: Do, ré, mi, fa, sol, la, si, do
-- English version
staff :: Octave -> Dur -> [Music Pitch]
staff octave duree = map (\n -> n octave duree) [c, d, e, f, g, a, b] ++ [(c (octave+1) duree)]


hautBas :: Octave -> Dur -> [Music Pitch]
hautBas octave duree = reverse $ basHaut octave duree

basHaut :: Octave -> Dur -> [Music Pitch]
basHaut octave duree = bas octave duree  ++ haut octave duree

bas :: Octave -> Dur -> [Music Pitch]
bas  octave duree = reverse $ haut octave duree

haut :: Octave -> Dur -> [Music Pitch]
haut octave duree = staff octave duree 

-- gamme sn ++ (reverse $ gamme tn)

gamme duree = staff 4 duree  ++ (reverse $ staff 4 duree )
       ++ (reverse $ staff 3 duree) ++ (staff 3 duree) ++ (reverse $ staff 3 duree)
       ++ (reverse $ staff 2 duree) ++ (reverse $ staff 1 duree)

